--  Declare Saved Variables
farmed_options = 
{
    show=true,
    slotcount=true,
    ore=true,
    herb = true,
    element=true,
    stone=true,
    gems=true,
    cloth=true,
    leather=true,
    other=true,
    uncommon=true,
    rare=true,
    fish=true;
    money=true,
  
};

--- Declare Other Variables



--- Init Code and Support Functions

function farmed_Message(msg)
    DEFAULT_CHAT_FRAME:AddMessage("|cFF2080D0[Farmed]|r "..msg);
end

function farmed_OnLoad(self)

    SLASH_FARMED1="/farmed";
    SlashCmdList["FARMED"] = farmed_SlashCommand;
    
   

    
  
   
    
    
    
    this:RegisterEvent("ADDON_LOADED");
    this:RegisterEvent("BAG_UPDATE");
    this:RegisterEvent("VARIABLES_LOADED");
    farmed_Message(farmed_lang_loaded);

end

-- Command Line Manager

function farmed_SlashCommand(msg)
   
    
    msg = string.lower(msg);
   local args = {};
   for word in string.gmatch(msg, "[^%s]+") do
   	table.insert(args, word);
   end
   
   ----PROCESS COMMAND LINE
   
   if ( args[1] ) then
	  if ( args[1] == "show" ) then
	     farmed_show();
	  elseif ( args[1] == "hide" ) then
	      farmed_hide();
       elseif ( args[1] == "options" ) then
	      FarmedOptions:Show();
      else
         farmed_Message("|cffff0000Unrecognised command.");
        
      end
    else
        farmed_Message(farmed_lang_optmain);
        farmed_Message(farmed_lang_optcom1);
        farmed_Message(farmed_lang_optcom2);
        farmed_Message(farmed_lang_optcom3);
    end
end

function farmed_toggle()
    if (farmed_options.show) then
        farmed_hide();
    else
        farmed_show();
    end
end

function farmed_show()
    farmed_options.show=true;
    FarmedOptions_show:SetChecked(true);
    Farmed:Show();
end

function farmed_hide()
    Farmed:Hide();
    farmed_options.show=false;
    FarmedOptions_show:SetChecked(false);
end

function farmed_write(htmltext, rows)
    Farmed_html:SetText(htmltext);
    --resize window to take into account html size
    Farmed_html:SetHeight((rows*11));
    Farmed:SetHeight((rows*11)+15);
end
--- Core Processing Loop
function farmed_gen()
    local rowcount=2;
    local html="<html><body>";
    
    --- Get Money
  if (farmed_options.money) then
        html = html .. "<h2>|cFF91D0F2" .. farmed_lang_money .. " |r";
        
        nmoney=GetMoney();
        ncopper = mod(nmoney,100);
        ngold = floor(nmoney/10000);
        nsilver=floor((nmoney-(ngold*10000))/100);
        
        html = html .. ngold .. "|cFFA88905g|r"..nsilver.."|cFF807979s|r"..ncopper.."|cFF966942c|r<br/><br/></h2>";
        rowcount=rowcount+2;
  end
    
    --- Get Bag Slot Count and items 
        if (farmed_options.slotcount) then
            html = html .. "<h2>|cFF91D0F2" .. farmed_lang_bags .. " |cFFFFF000";
        end
        local totslots=0;
        local freeslots=0;
        local itemblock="";
        local itemcount=0;
        local il=nil;
        
        
        if (farmed_options.slotcount or farmed_options.rare or farmed_options.uncommon) then
                for n= 0,4 do
                    local slots = GetContainerNumSlots(n);
                    totslots=totslots+slots;
                    
                    for f= 1,slots do
                        il=GetContainerItemLink(n,f);
                        if (il==nil) then
                            freeslots=freeslots+1;
                        else
                            local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(il);
                            if (itemType~=nil) then 
                                if (string.find(farmed_lang_ItemFilter, itemType) ~= nil) then
                                    if ((farmed_options.uncommon and itemRarity==2) or (farmed_options.rare and itemRarity>2)) then
                                        local r,g,b, colcode = GetItemQualityColor(itemRarity);
                                       itemblock = itemblock .. "<P><A href = 'B"..n..f.."'>" .. colcode .. itemName .. "|r</A></P>";
                                         -- itemblock = itemblock .. "<p>"..itemLink.."</p>";
                                        itemcount=itemcount+1;
                                        if (strlen(itemName)>30) then
                                            itemcount=itemcount+1;
                                        end
                                    end
                                end
                            end
                        end
                    end
                
                end
        end
        
        if (farmed_options.slotcount) then
            html = html .. freeslots .."/" .. totslots .. " |r</h2>";
            rowcount=rowcount+1;
        end
    --end
    --- Generate Item List
    if (farmed_options.rare or farmed_options.uncommon  ) then
        if (itemcount>0) then
            html = html .. "<h3><br/>|cFF91D0F2" .. farmed_lang_items .. " " .. farmed_lang_gathered .. "|r</h3>";
            html = html .. itemblock;
            rowcount=rowcount+itemcount+2;
        end
    end
    
    --- Process List
    
    local resh, resc;
    
    if (farmed_options.ore) then
        resh, resc = farmed_checkbag(farmed_ore,farmed_lang_ore);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
    if (farmed_options.stone) then
        resh, resc = farmed_checkbag(farmed_stone,farmed_lang_stone);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
    if (farmed_options.herb) then
        resh, resc = farmed_checkbag(farmed_herb,farmed_lang_herb);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
    if (farmed_options.element) then
        resh, resc = farmed_checkbag(farmed_element,farmed_lang_element);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
    if (farmed_options.gems) then
        resh, resc = farmed_checkbag(farmed_gem,farmed_lang_gem);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
    if (farmed_options.cloth) then
        resh, resc = farmed_checkbag(farmed_cloth,farmed_lang_cloth);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
    if (farmed_options.leather) then
        resh, resc = farmed_checkbag(farmed_leather,farmed_lang_leather);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
    if (farmed_options.other) then
        resh, resc = farmed_checkbag(farmed_other,farmed_lang_other);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    
     if (farmed_options.fish) then
        resh, resc = farmed_checkbag(farmed_fish,farmed_lang_fish);
        html = html ..resh;
        rowcount=rowcount+resc;
    end
    --Finish HTML
    
    html =html .."</body></html>";
    
   -- farmed_Message(html);
    
    farmed_write(html, rowcount)
end

function farmed_checkbag(typearray,typename)
    
    local htmlblock=""
    
    local has_title=false;
    local icount=0;
    local rc=0;
    
    for index,value in ipairs(typearray) do 
        
        local icount=GetItemCount(value);
        if (icount >0) then
        
            local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(value);
        
            if (has_title==false) then
                htmlblock = htmlblock .. "<h3><br/>|cFF91D0F2" .. typename .. " " .. farmed_lang_gathered .. "|r</h3>";
                rc=rc+2;
                has_title=true;
            end
            
             local r,g,b
            if (itemRarity<0 or itemRarity>6) then
                r=1;
                g=0;
                b=0;
            else
                r,g,b, colcode = GetItemQualityColor(itemRarity);
            end
            
            htmlblock = htmlblock .. "<p><A href='I"..value.."'>" .. colcode .. itemName .. "</A>: |cFFFFF000" .. icount .." |r</p>";
            rc=rc+1;
            
            --farmed_Message(htmlblock);
        end
    end

    return htmlblock, rc;
end



--Event Management
function farmed_showitem(citem)
        GameTooltip_SetDefaultAnchor(GameTooltip, Farmed);
       --farmed_Message("link clicked:" .. citem);
        
       
        
        if (strsub(citem,1,1)=="B") then
            local nbag = tonumber(strsub(citem,2,2));
            local nslot= tonumber(strsub(citem,3));
            --farmed_Message("link clicked:B=" .. nbag..", S="..nslot);
            
            local il=GetContainerItemLink(nbag,nslot);
            
            GameTooltip:SetHyperlink(il);
            --GameTooltip:SetBagItem(nbag, nslot);
        else
            nitem = tonumber(strsub(citem,2));
            local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(nitem);
             GameTooltip:SetHyperlink(itemLink);
        end
        GameTooltip:Show();
end

function farmed_event()
    if (event=="ADDON_LOADED") then
        
        
        
    elseif (event=="VARIABLES_LOADED") then
            if (farmed_options.show==false) then
                farmed_hide();
            end
        
            farmed_gen();
            
            ---Init Option Dlg
            FarmedOptions_show:SetChecked(farmed_options.show);
            FarmedOptions_money:SetChecked(farmed_options.money);
            FarmedOptions_bags:SetChecked(farmed_options.slotcount);
            FarmedOptions_uncommon:SetChecked(farmed_options.uncommon);
            FarmedOptions_rare:SetChecked(farmed_options.rare);
            FarmedOptions_ore:SetChecked(farmed_options.ore);
            FarmedOptions_herb:SetChecked(farmed_options.herb);
            FarmedOptions_element:SetChecked(farmed_options.element);
            FarmedOptions_stone:SetChecked(farmed_options.stone);
            FarmedOptions_gems:SetChecked(farmed_options.gems);
            FarmedOptions_cloth:SetChecked(farmed_options.cloth);
            FarmedOptions_leather:SetChecked(farmed_options.leather);
            FarmedOptions_other:SetChecked(farmed_options.other);
            FarmedOptions_fish:SetChecked(farmed_options.fish);
            
            FarmedOptions_Sect1:SetText(farmed_opt_general);
            FarmedOptions_Sect101:SetText(farmed_opt_show);
            FarmedOptions_Sect102:SetText(farmed_opt_money);
            FarmedOptions_Sect103:SetText(farmed_opt_bags);
            
            FarmedOptions_Sect2:SetText(farmed_opt_items);
            FarmedOptions_Sect201:SetText(farmed_opt_uncommon);
            FarmedOptions_Sect202:SetText(farmed_opt_rare);
            
            FarmedOptions_Sect3:SetText(farmed_opt_materials);
            FarmedOptions_Sect301:SetText(farmed_opt_ore);
            FarmedOptions_Sect302:SetText(farmed_opt_stone);
            FarmedOptions_Sect303:SetText(farmed_opt_herbs);
            FarmedOptions_Sect304:SetText(farmed_opt_elements);
            FarmedOptions_Sect305:SetText(farmed_opt_gems);
            FarmedOptions_Sect306:SetText(farmed_opt_cloth);
            FarmedOptions_Sect307:SetText(farmed_opt_leather);
            FarmedOptions_Sect308:SetText(farmed_opt_fish);
            FarmedOptions_Sect309:SetText(farmed_opt_other);
        
    elseif (event=="BAG_UPDATE") then
    
        farmed_gen();
    
    end


end
